/*
General constants and macros
*/
#pragma once

const int maxNQualities= 16;	// max number of quality layers
const int maxNTimeSlots= 100;	// max length of the video in timeslots
const int maxWindowSize= 32;	// max sliding window size
const int maxNPieces= maxNQualities*maxWindowSize;	// max number of pieces in a video
const int maxSize = 1000;		// max bandwidth capacity in a time slot
const int maxTotalSize = maxNTimeSlots*maxSize;	// max sum of bandwidth capacities for all time slots
const int maxOfflineBuffer = maxNTimeSlots + maxWindowSize;	// max length of the video increased by the setup length

const bool DEBUG = true;		// can be used in the details of the output

typedef std::pair<int, double> tPieceUtility; // piece index, utility pair

#define max(i, j) (i)>(j) ? (i) : (j)	
#define min(i, j) (i)<(j) ? (i) : (j)
